<template>
  <!-- Features -->
  <div class="feature-map">
    <div class="heading">
      <h2 class="mb-4 h3">Features & Usability</h2>

      <!-- Git rss notifications -->
      <a id="git-notification" class="btn badge-pill btn-light">
        <g-image
          class="dark-invert"
          src="~/assets/img/symbols/git-notification.svg"
        />
      </a>
      <b-popover
        target="git-notification"
        triggers="hover"
        title="Pro Tip"
        placement="bottomleft"
      >
        Use
        <a target="_blank" class="link" href="http://github.com/ubports"
          >GitHub</a
        >
        to subscribe to the linked Issues. So, whenever bugs get solved (or a
        fix needs testing) you will know about that.
      </b-popover>
    </div>

    <!--Usability-->
    <div class="usability-description row mb-5">
      <div class="col-lg-6 col-md-12">
        <p class="small mb-2 light">
          Automated Usability (<span class="bold">beta</span>)
        </p>
        <p>{{ progressStage }}</p>
      </div>
    </div>
    <!-- Feature list-->
    <div class="features">
      <ul
        v-for="featureCategory in portStatus"
        :key="featureCategory.categoryName"
      >
        <li>
          <p class="small mr-2 light">{{ featureCategory.categoryName }}:</p>
        </li>
        <li v-for="feature in featureCategory.features" :key="feature.name">
          <span v-if="feature.value === '+'" class="feature-icon"
            ><g-image src="~/assets/img/feature-matrix/working.svg" />
            <span v-if="feature.global"
              >&nbsp;<g-image
                class="dark-invert"
                src="~/assets/img/feature-matrix/global.svg" /></span
            >&nbsp;</span
          >
          <span v-else-if="feature.value === '+-'" class="feature-icon"
            ><g-image
              class="dark-invert"
              src="~/assets/img/feature-matrix/partial.svg"
            />
            <span v-if="feature.global"
              >&nbsp;<g-image
                class="dark-invert"
                src="~/assets/img/feature-matrix/global.svg" /></span
            >&nbsp;</span
          >
          <span v-else-if="feature.value === '-'" class="feature-icon"
            ><g-image src="~/assets/img/feature-matrix/not-working.svg" />
            <span v-if="feature.global"
              >&nbsp;<g-image
                class="dark-invert"
                src="~/assets/img/feature-matrix/global.svg" /></span
            >&nbsp;</span
          >
          <span v-else class="feature-icon"
            ><g-image
              class="dark-invert"
              src="~/assets/img/feature-matrix/untested.svg"
            />
            <span v-if="feature.global"
              >&nbsp;<g-image
                class="dark-invert"
                src="~/assets/img/feature-matrix/global.svg" /></span
            >&nbsp;</span
          >

          <a
            v-if="feature.bugTracker"
            :href="feature.bugTracker"
            :style="{ color: feature.value != '+' ? '#555' : 'inherit' }"
            target="_blank"
            rel="noreferrer noopener"
            >{{ feature.name }}</a
          >
          <span
            v-else
            :style="{ color: feature.value != '+' ? '#555' : 'inherit' }"
            >{{ feature.name }}</span
          >
        </li>
      </ul>
    </div>

    <div class="feature-legend row mt-5">
      <div class="col-lg-3 col-md-6 card-body g-0">
        <g-image src="~/assets/img/feature-matrix/working.svg" />
        <span class="bold"> Working</span>
        <p>Confirmed, depending on the maintenance</p>
      </div>

      <div class="col-lg-3 col-md-6 card-body g-0">
        <g-image src="~/assets/img/feature-matrix/not-working.svg" />
        <span class="bold">Not Working</span>
        <p>
          If there is a link here, follow it to learn more'<g-image
            class="dark-invert"
            src="~/assets/img/symbols/bell-notification.svg"
          />'
        </p>
      </div>

      <div class="col-lg-3 col-md-6 card-body g-0">
        <g-image
          class="dark-invert"
          src="~/assets/img/feature-matrix/partial.svg"
        />
        <span class="bold mb-3"> Partial</span>
        <p>Working to some extent but with issues</p>
      </div>

      <div class="col-lg-3 col-md-6 card-body g-0">
        <g-image
          class="dark-invert"
          src="~/assets/img/feature-matrix/global.svg"
        /><span class="bold"> Global Issue</span>
        <p>Issue is not specific to this device</p>
      </div>

      <div v-if="untestedCount" class="col-6 card-body g-0">
        <g-image
          class="dark-invert"
          src="~/assets/img/feature-matrix/untested.svg"
        />
        <span class="bold"> Untested</span>
        <p>Subject to port development</p>
      </div>
    </div>
  </div>
</template>

<script>
import { BPopover } from "bootstrap-vue";

export default {
  name: "PortStatus",
  components: {
    BPopover
  },
  props: {
    portStatus: {
      type: Array,
      default: function () {
        return [];
      }
    },
    progressStage: {
      type: String,
      default: ""
    },
    untestedCount: {
      type: Number,
      default: 0
    }
  }
};
</script>
